/* %W% %E% */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

//----------------------------------------------------------------------------
// Change History:
//
// 9/98 created  rtw
//----------------------------------------------------------------------------


package ibmspace.client;

import java.util.*;
import java.awt.event.*;


public class ActionSource
{
    protected Vector  fActionListeners;

    public ActionSource()
    {
	fActionListeners = new Vector ();
    }

    public void addActionListener (ActionListener listener)
    {
	if (!fActionListeners.contains (listener))
	    fActionListeners.addElement (listener);
    }

    public void removeActionListener (ActionListener listener)
    {
	fActionListeners.removeElement (listener);
    }

    public void notifyListeners (Object source, String command)
    {
	ActionEvent event = new ActionEvent (source, ActionEvent.ACTION_PERFORMED, command);

	for (int i=0; i<fActionListeners.size(); i++)
	    {
		ActionListener listener = (ActionListener)fActionListeners.elementAt (i);
		listener.actionPerformed (event);
	    }

    }

}
