/* %W% %E% */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

// This is where it all begins on the client side.  It creates
// the main frame.


//----------------------------------------------------------------------------
// Change History:
//
// 9/98 created  rtw
//----------------------------------------------------------------------------


package ibmspace.client;

import javax.swing.UIManager;
import java.awt.*;

public class SpaceConquestUI
{
    boolean packFrame = false;

    //Construct the application
  
    public SpaceConquestUI(String username)
    {
	SpaceFrame frame = new SpaceFrame(username);
	//Validate frames that have preset sizes
	//Pack frames that have useful preferred size info, e.g. from their layout
	if (packFrame)
	    frame.pack();
	else
	    frame.validate();
	//Center the window
	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = frame.getSize();
	if (frameSize.height > screenSize.height)
	    frameSize.height = screenSize.height;
	if (frameSize.width > screenSize.width)
	    frameSize.width = screenSize.width;
	frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
	frame.setVisible(true);
    }
    //Main method
  
    public static void main(String[] args)
    {
	try 
	    {
		UIManager.setLookAndFeel(new com.sun.java.swing.plaf.windows.WindowsLookAndFeel());
	    }
	catch (Exception e)
	    {
	    }

	new SpaceConquestUI (args[0]);
    }
}
