/* %W% %E% */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

//----------------------------------------------------------------------------
// Change History:
//
// 9/98     rtw   created
//----------------------------------------------------------------------------


package ibmspace.common;

import java.lang.reflect.Array;


public class BudgetSummary implements java.io.Serializable
{
    private String[]    fNames;
    private double[]    fPercentages;


    public BudgetSummary (int numItems, String[] names, double[] percentages)
    {
	fNames = names;
	fPercentages = percentages;
    }

    public String[] getNames ()
    {
	return fNames;
    }

    public double getPercentage (String name)
    {
	for (int i=0; i<Array.getLength(fNames); i++) {
	    if ( fNames[i].equals (name) ) {
		return fPercentages[i];
	    }
	}
	return 0;
    }

    public void setPercentage (String name, double percentage)
    {
	for (int i=0; i<Array.getLength(fNames); i++) {
	    if ( fNames[i].equals (name) ) {
		fPercentages[i] = percentage;
	    }
	}
    }

    public String toString ()
    {
	String s = "(";
	int num = Array.getLength (fNames);
	for (int i=0; i<num; i++) {
	    s += "(" + fNames[i] + "," + String.valueOf(fPercentages[i]) + ")" + ",";
	}
	s += ")";
	return s;
    }

}



