/* %W% %E% */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

//----------------------------------------------------------------------------
// Change History:
//
// 9/98 created  rtw
//----------------------------------------------------------------------------


package ibmspace.server;

import java.io.Serializable;


public class BudgetItem implements Serializable
{
    private Investment  fInvestment;
    private int         fPercentage;

    public BudgetItem (Investment investment, int percentage)
    {
	fInvestment = investment;
	fPercentage = percentage;
    }

    public BudgetItem (Investment investment)
    {
	fInvestment = investment;
	fPercentage = 0;
    }

    public Investment getInvestment ()
    {
	return fInvestment;
    }

    public int getPercentage ()
    {
	return fPercentage;
    }

    public void setInvestment (Investment investment)
    {
	fInvestment = investment;
    }

    public void setPercentage (int percentage)
    {
	fPercentage = percentage;
    }

    public String getName ()
    {
	return fInvestment.getName ();
    }

    public String toString ()
    {
	String s = getName() + "(";
	Object o = fInvestment;
	if ( o.getClass().getName() == "Budget" ) {
	    Budget b = (Budget)fInvestment;
	    s += b.toString ();
	} else {
	    s += fInvestment.getName ();
	}
	s += "," + String.valueOf (fPercentage) + ")";
	return s;
    }

}
