/* %W% %E% */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

//----------------------------------------------------------------------------
// Change History:
//
// 9/98 created  rtw
//----------------------------------------------------------------------------


package ibmspace.server;


public class Mining implements Investment, java.io.Serializable
{
    public static double    MINING_COST = 0.1;

    private Player          fPlayer;
    private PlanetImpl      fPlanet;

    public Mining (PlanetImpl planet, Player player)
    {
	fPlayer = player;
	fPlanet = planet;
    }

    public String getName ()
    {
	return "Mining";
    }

    public void invest (long dollars)
    {
	long metal = 0;

	if ( dollars > 0 ) {
	    long total = fPlanet.getMetal ();
	    if ( total > 0 ) {
		double d = dollars;
		double efficiency = total / 10000.0;
		metal = (long)(d / MINING_COST * efficiency);

		if ( metal > total ) {
		    metal = total;
		}

		fPlanet.removeMetal (metal);
		fPlayer.addShipMetal (metal);
	    }
	}
    }

}
