/* %W% %E% */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

//----------------------------------------------------------------------------
// Change History:
//
// 9/98 created  rtw
//----------------------------------------------------------------------------

package ibmspace.server;

import ibmspace.common.TechProfile;


public class ResearchLab implements Investment, java.io.Serializable
{
    private Budget        fTechBudget;
    private Technology    fRange;
    private Technology    fSpeed;
    private Technology    fWeapons;
    private Technology    fShields;
    private Technology    fMini;

    public ResearchLab (TechProfile profile)
    {
	fRange = new Technology ("Range", profile.getRange());
	fSpeed = new Technology ("Speed", profile.getSpeed());
	fWeapons = new Technology ("Weapons", profile.getWeapons());
	fShields = new Technology ("Shields", profile.getShields());
	fMini = new Technology ("Mini", profile.getMini());

	fTechBudget = new Budget ("Technology");
	fTechBudget.addBudgetItem (new BudgetItem(fRange, 20));
	fTechBudget.addBudgetItem (new BudgetItem(fSpeed, 20));
	fTechBudget.addBudgetItem (new BudgetItem(fWeapons, 20));
	fTechBudget.addBudgetItem (new BudgetItem(fShields, 20));
	fTechBudget.addBudgetItem (new BudgetItem(fMini, 20));
    }

    public String getName ()
    {
	return "Technology";
    }

    public void invest (long investment)
    {
	fTechBudget.invest (investment);
    }

    public TechProfile getTechProfile ()
    {
	int range = fRange.getLevel ();
	int speed = fSpeed.getLevel ();
	int weapons = fWeapons.getLevel ();
	int shields = fShields.getLevel ();
	int mini = fMini.getLevel ();
	return new TechProfile (range, speed, weapons, shields, mini);
    }

    public Budget getTechnologyBudget ()
    {
	return fTechBudget;
    }

}
