/* %W% %E% */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

//----------------------------------------------------------------------------
// Change History:
//
// 9/98 created  rtw
//----------------------------------------------------------------------------


package ibmspace.server;


public class ShipSavings implements Investment, java.io.Serializable
{
    private long    fSavings;
    private double  fInterestRate;

    public ShipSavings (long initial)
    {
	fSavings = initial;
	fInterestRate = 0.07;
    }

    public ShipSavings ()
    {
	fSavings = 0;
	fInterestRate = 0.07;
    }

    public String getName ()
    {
	return "Ship Savings";
    }

    public void setInterestRate (double rate)
    {
	fInterestRate = rate;
    }

    public double getInterestRate ()
    {
	return fInterestRate;
    }

    public long computeInterest ()
    {
	return (long)(fSavings * fInterestRate);
    }

    public void invest (long investment)
    {
	fSavings += computeInterest ();
	fSavings += investment;
    }

    public long getSavings ()
    {
	return fSavings;
    }

    public void withdraw (long amount)
    {
	fSavings -= amount;
    }



}
