/* %W% %E% */
/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

//----------------------------------------------------------------------------
// Change History:
//
// 9/98 created  rtw
//----------------------------------------------------------------------------


package ibmspace.server;


public class Technology implements Investment, java.io.Serializable
{
    private String      fName;
    private int         fLevel;
    private long        fInvestment;
    private long        fRequiredInvestment;

    static private int  UNIT_INVESTMENT = 1000;

    public Technology (String name, int initialLevel)
    {
	fName = name;
	fLevel = initialLevel;
	fInvestment = 0;
	fRequiredInvestment = (fLevel+1) * UNIT_INVESTMENT;
    }

    public String getName ()
    {
	return fName;
    }

    public void invest (long investment)
    {
	// formula:  1. each level requires level* UNIT_INVESTMENT to reach
	//           2. investments are dampened by a random percentage

	fInvestment += investment * Math.random () * 1.25;
	if ( fInvestment >= fRequiredInvestment ) {
	    fLevel ++;
	    fInvestment -= fRequiredInvestment;
	    fRequiredInvestment = (fLevel+1) * UNIT_INVESTMENT;
	}

    }

    public int getLevel ()
    {
	return fLevel;
    }

}
